window.addEventListener("load", em_addonDonateInit, true);
var prefO = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch2);
var observO = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
var em_observer = {
  observe: function(subject,topic,data) {
    prefO.setBoolPref("extensions.euromillions.function.supressDonateText", true);
    var db_strings = document.getElementById("emstrbundle");
    alert(db_strings.getString("removeDonateConfirm"));
  }
};

function em_addonDonateInit() {

	// The donate text can be either: 
	//    1) shown 
	//    2) supressed indefinitely (or until next major update) with <supressDonateText> 
	//    3) cleared for an interval of time before it comes back with <donateTextInterval> Cleared with the X button
	
	// Test pref to see if we should supress donate text
	try {
		var supDonateText = prefO.getBoolPref("extensions.euromillions.function.supressDonateText");  // if not set, errors, goes onto the interval test
		if(supDonateText)
			return;
	} catch (e) {}
	
	// Test clear interval, currently 2 months to begin with, 6 months if click on donate link (60 and 180 days)
	try {
		var intervalSet = prefO.getCharPref("extensions.euromillions.function.donateTextInterval");  // if not set, errors, will go on to put the donate text on
		var intervalDays = prefO.getIntPref("extensions.euromillions.function.donateTextHideDays");
		intervalSet = parseInt(intervalSet);
		var now = ( new Date() ).getTime();
		
		var currInterval = now - intervalSet;  // milliseconds
		currIntervalDays = parseInt(currInterval / 1000 / 60 / 60 / 24);

		if(currIntervalDays < intervalDays)
			return;
		
	} catch (e) {}
	
	window.addEventListener('unload', em_addonDonateClose, false);
	observO.addObserver(em_observer,"removeDonatePressed",false);
	
	db_gExtensionsView = document.getElementById("extensionsView");
	db_gExtensionsView.addEventListener("select", em_setDonateText, false);
	em_setDonateText();
	
	// Add this to make sure text is there after switching groups (buttons at top)
	var viewGroup = document.getElementById("viewGroup");
	var currCommand = viewGroup.getAttribute("onclick");
	viewGroup.setAttribute("onclick", currCommand + " window.setTimeout(em_setDonateText, 200);");
	
}

function em_setDonateText() {
	
	// Check if the text is already there, if so return
	if(document.getElementById("emDonateContainerOn"))
		return;
	
  var win = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService().QueryInterface(Components.interfaces.nsIWindowMediator).getMostRecentWindow("navigator:browser");
	var myext = document.getElementById("urn:mozilla:item:"+win.em.ID);
	
	var emDonateContainer = document.getElementById("emDonateContainer");
	var emDonateSpacer = document.getElementById("emDonateSpacer");
	var emDonateClearImg = document.getElementById("emDonateClearImg");
	
	var nameVersionBox;
	try {
		// this ext is currently selected
		nameVersionBox = document.getAnonymousElementByAttribute(myext, "anonid", "addonNameVersion");
		if(!nameVersionBox)  // this ext is not currently selected
			nameVersionBox = document.getAnonymousElementByAttribute(myext, "class", "addon-name-version");
		
		var spacerClone = emDonateSpacer.cloneNode(true);
		spacerClone.hidden = false;
		//spacerClone.id = "emDonateSpacerOn";
		nameVersionBox.appendChild(spacerClone);
		
		var clearImgClone = emDonateClearImg.cloneNode(true);
		clearImgClone.hidden = false;
		nameVersionBox.appendChild(clearImgClone);
		
		var containerClone = emDonateContainer.cloneNode(true);
		containerClone.id = "emDonateContainerOn";
		containerClone.hidden = false;
		nameVersionBox.appendChild(containerClone);
	} catch (e) {}
	
}

function em_openDonate() {
		
	// Open page in new tab if browser is available, otherwise set a pref to open the tab next time there is a browser window
	// (if they are seeing the addons updater when the app starts before the browser is available, 
	//    opening the standard browser messes up session save and causes other problems)

	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
    var wmed = wm.QueryInterface(Components.interfaces.nsIWindowMediator);
    
    var win = wmed.getMostRecentWindow("navigator:browser");
    if (!win) {
    	
    	//win = window.openDialog("chrome://browser/content/browser.xul", "Downbar_Donation", "modal=yes,location=yes,resizable=yes,scrollbars=yes,status=yes", "http://downloadstatusbar.mozdev.org/donateRedirect.html", null, null);
    	
    	prefO.setBoolPref("extensions.euromillions.function.openDonatePage", true);
    	var db_strings = document.getElementById("emstrbundle");
		alert(db_strings.getString("newTabForDonate"));
    }
    else {
    	var content = win.document.getElementById("content");
    	content.selectedTab = content.addTab("http://euromillions.mozdev.org/");//http://downloadstatusbar.mozdev.org/donateRedirect.html	
    }
    
    // Set to hide with interval and change the interval to 6 months after donate link is clicked
    prefO.setIntPref("extensions.euromillions.function.donateTextHideDays", 180);
    var now = ( new Date() ).getTime();
	prefO.setCharPref("extensions.euromillions.function.donateTextInterval", now);
	
}

// Using observer service to do this so that if more than one of my extensions is installed, all of them can respond to the same keypress
function em_removeDonate() {
	observO.notifyObservers(null,"removeDonatePressed", null);
}

// Clicked the x button to clear - set curr time to base interval off of
function em_donateClearInterval() {
	
	var now = ( new Date() ).getTime();
	prefO.setCharPref("extensions.euromillions.function.donateTextInterval", now);
	
	var db_strings = document.getElementById("emstrbundle");
	alert(db_strings.getString("removeDonateConfirm"));
	
}

function em_addonDonateClose() {
	
	try {
		observO.removeObserver(em_observer,"removeDonatePressed");
	} catch(e){}
}